commit acbc9fffa5dbf5eab10ad785c951bf4120099cee
Author: Tomáš Šimandl <tomas.simandl@gmail.com>
Date:   Mon Aug 20 11:17:58 2018 +0200

    Changed format of JSON between frontend and backend.

diff --git a/sources/src/cz/zcu/kiv/offscreen/api/BaseEdge.java b/sources/src/cz/zcu/kiv/offscreen/api/BaseEdge.java
new file mode 100644
index 0000000..5a62f65
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/BaseEdge.java
@@ -0,0 +1,78 @@
+package cz.zcu.kiv.offscreen.api;
+
+/**
+ * Class represents edge. Class contains attributes which are common for input JSON format and for
+ * output JSON format (JSON between frontend and backend)
+ */
+public class BaseEdge {
+    /** identification number of edge */
+    private int id;
+    /** original ID of vertex from edge leads */
+    private int from;
+    /** original ID of vertex where edge leads */
+    private int to;
+    /** additional info */
+    private String text;
+
+    public BaseEdge(int id, int from, int to, String text) {
+        this.id = id;
+        this.from = from;
+        this.to = to;
+        this.text = text;
+    }
+
+    public int getId() {
+        return id;
+    }
+
+    public void setId(int id) {
+        this.id = id;
+    }
+
+    public int getFrom() {
+        return from;
+    }
+
+    public void setFrom(int from) {
+        this.from = from;
+    }
+
+    public int getTo() {
+        return to;
+    }
+
+    public void setTo(int to) {
+        this.to = to;
+    }
+
+    public String getText() {
+        return text;
+    }
+
+    public void setText(String text) {
+        this.text = text;
+    }
+
+    /**
+     * Generate hash code based on attributes {@code from} and {@code to}.
+     * @return generated hash code.
+     */
+    @Override
+    public int hashCode() {
+        return from * 100000 + to;
+    }
+
+    /**
+     * Two edges are equals where their {@code from} and {@code to} are equals.
+     *
+     * @param edge which will be compared with this instance
+     * @return tru if edges are equal, false otherwise
+     */
+    @Override
+    public boolean equals(Object edge) {
+        if (!(edge instanceof BaseEdge)) return false;
+
+        BaseEdge cmpEdge = (BaseEdge) edge;
+        return from == cmpEdge.from && to == cmpEdge.to;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/BaseVertex.java b/sources/src/cz/zcu/kiv/offscreen/api/BaseVertex.java
new file mode 100644
index 0000000..2fad2f0
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/BaseVertex.java
@@ -0,0 +1,87 @@
+package cz.zcu.kiv.offscreen.api;
+
+/**
+ * Class represents vertex. Class contains attributes which are common for input JSON format and for
+ * output JSON format (JSON between frontend and backend)
+ */
+public class BaseVertex {
+
+    /** New generated identification number. */
+    private int id;
+    /** Identification number which is in input file. */
+    private int originalId;
+    /** Title of vertex. */
+    private String title;
+    /** Index of vertex archetype. */
+    private int archetypeIndex;
+    /** Additional info. */
+    private String text;
+
+    public BaseVertex(int id, int originalId, String title, int archetypeIndex, String text) {
+        this.id = id;
+        this.originalId = originalId;
+        this.title = title;
+        this.archetypeIndex = archetypeIndex;
+        this.text = text;
+    }
+
+    public int getId() {
+        return id;
+    }
+
+    public void setId(int id) {
+        this.id = id;
+    }
+
+    public int getOriginalId() {
+        return originalId;
+    }
+
+    public void setOriginalId(int originalId) {
+        this.originalId = originalId;
+    }
+
+    public String getTitle() {
+        return title;
+    }
+
+    public void setTitle(String title) {
+        this.title = title;
+    }
+
+    public int getArchetype() {
+        return archetypeIndex;
+    }
+
+    public void setArchetype(int archetypeIndex) {
+        this.archetypeIndex = archetypeIndex;
+    }
+
+    public String getText() {
+        return text;
+    }
+
+    public void setText(String text) {
+        this.text = text;
+    }
+
+    /**
+     * Generate hash code which is based on {@code originalId}.
+     * @return generated has code
+     */
+    @Override
+    public int hashCode() {
+        return originalId;
+    }
+
+    /**
+     * Two vertices are equals when their {@code originalId} is equals.
+     * @param edge which will be compared with this instance
+     * @return true if vertices are equal, false otherwise
+     */
+    @Override
+    public boolean equals(Object edge) {
+        if (!(edge instanceof BaseVertex)) return false;
+        return originalId == ((BaseVertex) edge).originalId;
+    }
+}
\ No newline at end of file
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/Edge.java b/sources/src/cz/zcu/kiv/offscreen/api/Edge.java
new file mode 100644
index 0000000..edbeceb
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/Edge.java
@@ -0,0 +1,36 @@
+package cz.zcu.kiv.offscreen.api;
+
+import java.util.List;
+
+/**
+ * Class represents edge which is used for output JSON format (JSON between frontend and backend).
+ */
+public class Edge extends BaseEdge {
+
+    /**
+     * List of subedgeInfo.
+     * When two input edges are equals, in output their are in one record and their differences are in subedgeInfo.
+     */
+    private List<SubedgeInfo> subedgeInfo;
+
+    /**
+     * Create new edge.
+     * @param id new generated identification number
+     * @param from original ID of vertex from edge leads
+     * @param to original ID of vertex where edge leads
+     * @param text additional info
+     * @param subedgeInfo list which contains differences between equals edges
+     */
+    public Edge(int id, int from, int to, String text, List<SubedgeInfo> subedgeInfo) {
+        super(id, from, to, text);
+        this.subedgeInfo = subedgeInfo;
+    }
+
+    public List<SubedgeInfo> getSubedgeInfo(){
+        return subedgeInfo;
+    }
+
+    public void setSubedgeInfo(List<SubedgeInfo> subedgeInfo) {
+        this.subedgeInfo = subedgeInfo;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/GraphExport.java b/sources/src/cz/zcu/kiv/offscreen/api/GraphExport.java
new file mode 100644
index 0000000..bc5395a
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/GraphExport.java
@@ -0,0 +1,99 @@
+package cz.zcu.kiv.offscreen.api;
+
+import cz.zcu.kiv.offscreen.graph.EdgeArchetype;
+import cz.zcu.kiv.offscreen.graph.Graph;
+import cz.zcu.kiv.offscreen.graph.VertexArchetype;
+import cz.zcu.kiv.offscreen.graph.AttributeType;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.log4j.Logger;
+
+/**
+ * Class represents graph with all information about graph plus information about state in which used store graph.
+ * Class is used for creating of JSON which is send to frontend.
+ */
+public class GraphExport {
+
+    private List<Vertex> vertices;
+    private List<Edge> edges;
+    private List<VertexArchetype> vertexArchetypes;
+    private List<EdgeArchetype> edgeArchetypes;
+    private List<AttributeType> attributeTypes;
+    private Map<String, List<String>> possibleEnumValues;
+    private Map<String, String> archetypeIcons;
+
+    private List<Group> groups;
+    private List<Position> positions;
+    private List<SideBar> sideBar;
+    private int selectedVertex;
+    private int selectedEdge;
+
+    private Logger logger = Logger.getLogger(GraphExport.class);
+
+    public GraphExport(Graph graph) {
+        logger.trace("ENTRY");
+        this.vertices = new ArrayList<Vertex>(graph.getVertices().values());
+        this.edges = new ArrayList<Edge>(graph.getEdges());
+        this.vertexArchetypes = new ArrayList<VertexArchetype>(graph.getVertexArchetypes());
+        this.edgeArchetypes = new ArrayList<EdgeArchetype>(graph.getEdgeArchetypes());
+        this.attributeTypes = new ArrayList<>(graph.getAttributeTypes());
+        this.possibleEnumValues = graph.getPossibleEnumValues();
+        this.archetypeIcons = graph.getArchetypeIcons();
+        logger.trace("EXIT");
+    }
+
+    public List<Edge> getEdges() {
+        logger.trace("ENTRY");
+        logger.trace("EXIT");
+        return edges;
+    }
+
+    public List<Vertex> getVertices() {
+        logger.trace("ENTRY");
+        logger.trace("EXIT");
+        return vertices;
+    }
+
+    public List<VertexArchetype> getVertexArchetypes() {
+        return vertexArchetypes;
+    }
+
+    public List<EdgeArchetype> getEdgeArchetypes() {
+        return edgeArchetypes;
+    }
+
+    public List<AttributeType> getAttributeTypes() {
+        return attributeTypes;
+    }
+
+    public Map<String, List<String>> getPossibleEnumValues() {
+        return possibleEnumValues;
+    }
+
+    public Map<String, String> getArchetypeIcons() {
+        return archetypeIcons;
+    }
+
+    public List<Group> getGroups() {
+        return groups;
+    }
+
+    public List<Position> getPositions() {
+        return positions;
+    }
+
+    public List<SideBar> getSideBar() {
+        return sideBar;
+    }
+
+    public int getSelectedVertex() {
+        return selectedVertex;
+    }
+
+    public int getSelectedEdge() {
+        return selectedEdge;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/Group.java b/sources/src/cz/zcu/kiv/offscreen/api/Group.java
new file mode 100644
index 0000000..7373270
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/Group.java
@@ -0,0 +1,79 @@
+package cz.zcu.kiv.offscreen.api;
+
+import java.util.List;
+
+/**
+ * Class represents group of edges and their settings. Used in JSON between frontend and backend.
+ */
+public class Group {
+
+    /** Generated id of group which is unique only in groups. */
+    private int groupId;
+    /** Generated if of group which is unique in groups and vertexes. */
+    private int id;
+    /** Name of group */
+    private String name;
+    /** List of vertices id which belongs to this group */
+    private List<Integer> verticesId;
+    /** List of vertices id whose outgoing edges are visible. */
+    private List<Integer> verticesEdgeFromId;
+    /** List of vertices id whose incoming edges are visible. */
+    private List<Integer> verticesEdgeToId;
+
+    public Group(int groupId, int id, String name, List<Integer> verticesId, List<Integer> verticesEdgeFromId, List<Integer> verticesEdgeToId) {
+        this.groupId = groupId;
+        this.id = id;
+        this.name = name;
+        this.verticesId = verticesId;
+        this.verticesEdgeFromId = verticesEdgeFromId;
+        this.verticesEdgeToId = verticesEdgeToId;
+    }
+
+    public int getGroupId() {
+        return groupId;
+    }
+
+    public void setGroupId(int groupId) {
+        this.groupId = groupId;
+    }
+
+    public int getId() {
+        return id;
+    }
+
+    public void setId(int id) {
+        this.id = id;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public void setName(String name) {
+        this.name = name;
+    }
+
+    public List<Integer> getVerticesId() {
+        return verticesId;
+    }
+
+    public void setVerticesId(List<Integer> verticesId) {
+        this.verticesId = verticesId;
+    }
+
+    public List<Integer> getVerticesEdgeFromId() {
+        return verticesEdgeFromId;
+    }
+
+    public void setVerticesEdgeFromId(List<Integer> verticesEdgeFromId) {
+        this.verticesEdgeFromId = verticesEdgeFromId;
+    }
+
+    public List<Integer> getVerticesEdgeToId() {
+        return verticesEdgeToId;
+    }
+
+    public void setVerticesEdgeToId(List<Integer> verticesEdgeToId) {
+        this.verticesEdgeToId = verticesEdgeToId;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/Position.java b/sources/src/cz/zcu/kiv/offscreen/api/Position.java
new file mode 100644
index 0000000..452c16d
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/Position.java
@@ -0,0 +1,44 @@
+package cz.zcu.kiv.offscreen.api;
+
+/**
+ * Class is used for storing information about vertex/group relative position.
+ */
+public class Position {
+
+    /** Identification number of vertex or group which was generated in application. */
+    private int vertexId;
+    /** Relative X position. */
+    private float x;
+    /** Relative Y position */
+    private float y;
+
+    public Position(int vertexId, float x, float y) {
+        this.vertexId = vertexId;
+        this.x = x;
+        this.y = y;
+    }
+
+    public int getVertexId() {
+        return vertexId;
+    }
+
+    public void setVertexId(int vertexId) {
+        this.vertexId = vertexId;
+    }
+
+    public float getX() {
+        return x;
+    }
+
+    public void setX(float x) {
+        this.x = x;
+    }
+
+    public float getY() {
+        return y;
+    }
+
+    public void setY(float y) {
+        this.y = y;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/SideBar.java b/sources/src/cz/zcu/kiv/offscreen/api/SideBar.java
new file mode 100644
index 0000000..df26bd9
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/SideBar.java
@@ -0,0 +1,33 @@
+package cz.zcu.kiv.offscreen.api;
+
+/**
+ * Class store information about item in side bar.
+ */
+public class SideBar {
+
+    /** Identification number of vertex or group which was generated in application. */
+    private int vertexId;
+    /** Indicates if related vertexes of this item have visible icon which shows relation with this item. */
+    private boolean highlighted;
+
+    public SideBar(int vertexId, boolean highlighted) {
+        this.vertexId = vertexId;
+        this.highlighted = highlighted;
+    }
+
+    public int getVertexId() {
+        return vertexId;
+    }
+
+    public void setVertexId(int vertexId) {
+        this.vertexId = vertexId;
+    }
+
+    public boolean isHighlighted() {
+        return highlighted;
+    }
+
+    public void setHighlighted(boolean highlighted) {
+        this.highlighted = highlighted;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/SubedgeInfo.java b/sources/src/cz/zcu/kiv/offscreen/api/SubedgeInfo.java
new file mode 100644
index 0000000..f1fb208
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/SubedgeInfo.java
@@ -0,0 +1,37 @@
+package cz.zcu.kiv.offscreen.api;
+
+import java.util.List;
+
+public class SubedgeInfo {
+
+    /** Edge archetype index. */
+    private int archetype;
+    /** Original id of edge which is taken from input JSON file. */
+    private int originalId;
+    /** List of all tributes. Every attribute is stored in String array in pair as {attribute name, attribute value}. */
+    private List<String[]> attributes;
+
+    /**
+     * Create new subedgeInfo
+     * @param originalId Original id of edge which is taken from input JSON file.
+     * @param archetype Edge archetype index.
+     * @param attributes  List of all tributes. Every attribute is stored in String array in pair as {attribute name, attribute value}.
+     */
+    public SubedgeInfo(int originalId, int archetype, List<String[]> attributes) {
+        this.originalId = originalId;
+        this.archetype = archetype;
+        this.attributes = attributes;
+    }
+
+    public int getOriginalId() {
+        return originalId;
+    }
+
+    public int getArchetype() {
+        return archetype;
+    }
+
+    public List<String[]> getAttributes() {
+        return attributes;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/Vertex.java b/sources/src/cz/zcu/kiv/offscreen/api/Vertex.java
new file mode 100644
index 0000000..7101628
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/api/Vertex.java
@@ -0,0 +1,34 @@
+package cz.zcu.kiv.offscreen.api;
+
+import java.util.List;
+
+/**
+ * Class represents vertex which is used for output JSON format (JSON between frontend and backend)
+ */
+public class Vertex extends BaseVertex {
+
+    /** List of all tributes. Every attribute is stored in String array in pair as {attribute name, attribute value}. */
+    private List<String[]> attributes;
+
+    /**
+     * Create new vertex.
+     * @param id new generated identification number.
+     * @param originalId original identification number from input file
+     * @param title title of vertex
+     * @param archetypeIndex index of vertex archetype
+     * @param text additional info
+     * @param attributes List of all attributes. Every attribute is stored in String array in pair as {attribute name, attribute value}.
+     */
+    public Vertex(int id, int originalId, String title, int archetypeIndex, String text, List<String[]> attributes) {
+        super(id, originalId, title, archetypeIndex, text);
+        this.attributes = attributes;
+    }
+
+    public List<String[]> getAttributes() {
+        return attributes;
+    }
+
+    public void setAttributes(List<String[]> attributes) {
+        this.attributes = attributes;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java b/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java
index 2a1ddd6..4a7daaa 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java
@@ -1,11 +1,32 @@
 package cz.zcu.kiv.offscreen.graph;
 
+/**
+ * This class represents attribute of edge or vertex.
+ */
 public class Attribute {
-    int typeIndex;
-    Object value;
+    /** Index to array of attribute types which is defined in input JSON file */
+    private int typeIndex;
+    /** Value of attribute */
+    private Object value;
 
     public Attribute(int typeIndex, Object value) {
         this.typeIndex = typeIndex;
         this.value = value;
     }
+
+    public int getTypeIndex() {
+        return typeIndex;
+    }
+
+    public void setTypeIndex(int typeIndex) {
+        this.typeIndex = typeIndex;
+    }
+
+    public Object getValue() {
+        return value;
+    }
+
+    public void setValue(Object value) {
+        this.value = value;
+    }
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/AttributeType.java b/sources/src/cz/zcu/kiv/offscreen/graph/AttributeType.java
new file mode 100644
index 0000000..1240c67
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/AttributeType.java
@@ -0,0 +1,32 @@
+package cz.zcu.kiv.offscreen.graph;
+
+/**
+ * Class represents one attribute type which is used in input JSON file and in output JSON file (file between frontend
+ * and backend).
+ */
+public class AttributeType {
+    /** name of attribute */
+    public String name;
+    /** data type of attribute */
+    public GraphManager.AttributeDataType dataType;
+    /** additional info */
+    public String text;
+
+    public AttributeType(String name, GraphManager.AttributeDataType dataType, String text) {
+        this.name = name;
+        this.dataType = dataType;
+        this.text = text;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public GraphManager.AttributeDataType getDataType() {
+        return dataType;
+    }
+
+    public String getText() {
+        return text;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java
index 28c8519..71b1995 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java
@@ -12,4 +12,8 @@ public class EdgeArchetype {
     public String getName() {
         return  name;
     }
+
+    public String getText() {
+        return text;
+    }
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeImpl.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeImpl.java
index 38cadec..a696afe 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeImpl.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeImpl.java
@@ -1,101 +1,85 @@
 package cz.zcu.kiv.offscreen.graph;
 
-import cz.zcu.kiv.offscreen.api.EdgeInterface;
-import java.util.LinkedList;
-import java.util.List;
-import org.apache.log4j.Logger;
+import cz.zcu.kiv.offscreen.api.BaseEdge;
+
+import java.util.*;
 
 /**
- * This class represents edge.
- *
- * @author Jindra Pavlíková
+ * Class represents edge which is used for input JSON format.
  */
-public class EdgeImpl implements EdgeInterface {
+public class EdgeImpl extends BaseEdge {
 
-    private int edgeId;
-    private String from;
-    private String to;
-    private List<String> packageConnections;
-    private boolean isCompatible;
-    private List<SubedgeInfo> subedgeInfo;
-    private String compInfoJSON;
-    private Logger logger = Logger.getLogger(EdgeImpl.class);
+    /** original identification number which is defined in input file */
+    private int originalId;
+    /** index of edge archetype */
+    private int archetypeIndex;
+    /** Map contains attributes stored in key value format. Key is index to array of attribute types defined in input file */
+    private Map<Integer, Attribute> attributesMap;
 
     /**
-     * Inicialization of edge.
-     *
-     * @param edgeId id of edge
-     * @param from name of vertex which leads from the edge
-     * @param to name of vertex which leads to the edge
+     * Create new edge.
+     * @param id new generated identification number
+     * @param from original ID of vertex from edge leads
+     * @param to original ID of vertex where edge leads
+     * @param text additional info
+     * @param originalId original identification number which is defined in input file
+     * @param archetypeIndex index of edge archetype
      */
-    public EdgeImpl(int edgeId, String from, String to, boolean isCompatible, String compInfoJSON) {
-        logger.trace("ENTRY");
-        this.edgeId = edgeId;
-        this.from = from;
-        this.to = to;
-        this.packageConnections = new LinkedList<String>();
-        this.isCompatible = isCompatible;
-        this.compInfoJSON = compInfoJSON;
-        logger.trace("EXIT");
+    public EdgeImpl(int id, int from, int to, String text, int originalId, int archetypeIndex) {
+        super(id, from, to, text);
+        this.originalId = originalId;
+        this.archetypeIndex = archetypeIndex;
+        this.attributesMap = new HashMap<>();
     }
 
-    @Override
-    public String getFrom() {
-        logger.trace("ENTRY");
-        logger.trace("EXIT");
-        return from;
-
+    public Attribute getAttribute(int attrTypeIndex) {
+        return attributesMap.get(attrTypeIndex);
     }
 
-    @Override
-    public String getTo() {
-        logger.trace("ENTRY");
-        logger.trace("EXIT");
-        return to;
+    public Map<Integer, Attribute> getAttributesMap() {
+        return attributesMap;
     }
 
-    @Override
-    public int getId() {
-        logger.trace("ENTRY");
-        logger.trace("EXIT");
-        return edgeId;
-    }
 
-    @Override
-    public List<SubedgeInfo> getSubedgeInfo() {
-        return subedgeInfo;
+    public int getOriginalId() {
+        return originalId;
     }
 
-    @Override
-    public void setSubedgeInfo(List<SubedgeInfo> subedgeInfo) {
-        this.subedgeInfo = subedgeInfo;
+
+    public int getArchetype() {
+        return archetypeIndex;
     }
 
-    @Override
-    public boolean equals(Object edge) {
-        if (!(edge instanceof EdgeImpl)) return false;
-        EdgeImpl cmpEdge = (EdgeImpl) edge;
-        return from.equals(cmpEdge.from) && to.equals(cmpEdge.to);
+
+    public void addAttribute(int attrTypeIndex, Object value) {
+        Attribute attr = new Attribute(attrTypeIndex, value);
+        attributesMap.put(attrTypeIndex, attr);
     }
 
-    public List<String> getPackageConnections() {
-        logger.trace("ENTRY");
-        logger.trace("EXIT");
-        return this.packageConnections;
+    public void addAttributes(Map<Integer, Attribute> attributes) {
+        this.attributesMap.putAll(attributes);
     }
 
-    public void setPackageConnections(List<String> packageConnections) {
-        logger.trace("ENTRY");
-        this.packageConnections = packageConnections;
-        logger.trace("EXIT");
+    public void setOriginalId(int originalId) {
+        this.originalId = originalId;
     }
-    
-    public boolean getIsCompatible() {
-        return isCompatible;
+
+    public void setArchetypeIndex(int archetypeIndex) {
+        this.archetypeIndex = archetypeIndex;
     }
-    
-    public String getCompInfoJSON() {
-        return compInfoJSON;
+
+    /**
+     * Return list of attributes sorted by their key value in {@code attributeMap}
+     * @return sorted list
+     */
+    public List<Attribute> getSortedAttributes() {
+        List<Attribute> list = new ArrayList<>();
+        ArrayList<Integer> indices = new ArrayList<>(attributesMap.keySet());
+        //indices.sort(Integer::compareTo);
+        Collections.sort(indices);
+        for (Integer index : indices) {
+            list.add(attributesMap.get(index));
+        }
+        return list;
     }
-   
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/Graph.java b/sources/src/cz/zcu/kiv/offscreen/graph/Graph.java
new file mode 100644
index 0000000..6dfa501
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/Graph.java
@@ -0,0 +1,109 @@
+package cz.zcu.kiv.offscreen.graph;
+
+import cz.zcu.kiv.offscreen.api.Edge;
+import cz.zcu.kiv.offscreen.api.Vertex;
+import org.apache.log4j.Logger;
+
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+/**
+ * Class represents graph which is loaded from input JSON file.
+ */
+public class Graph {
+
+    private Map<String, Vertex> vertices;
+    private List<Edge> edges;
+    private List<VertexArchetype> vertexArchetypes;
+    private List<EdgeArchetype> edgeArchetypes;
+    private List<AttributeType> attributeTypes;
+    private Map<String, List<String>> possibleEnumValues;
+    private List<String> defaultGroupArchetypes;
+
+    private Map<String, String> archetypeIcons;
+    private Logger logger = Logger.getLogger(Graph.class);
+
+    public Graph() {
+        logger.trace("ENTRY");
+        this.vertices = new HashMap<String, Vertex>();
+        this.edges = new LinkedList<Edge>();
+        logger.trace("EXIT");
+    }
+
+    public List<Edge> getEdges() {
+        logger.trace("ENTRY");
+        logger.trace("EXIT");
+        return edges;
+    }
+
+    public List<VertexArchetype> getVertexArchetypes() {
+        return vertexArchetypes;
+    }
+
+    public List<EdgeArchetype> getEdgeArchetypes() {
+        return edgeArchetypes;
+    }
+
+    public void setVertexArchetypes(List<VertexArchetype> vertexArchetypes) {
+        this.vertexArchetypes = vertexArchetypes;
+    }
+
+    public  void setEdgeArchetypes(List<EdgeArchetype> edgeArchetypes) {
+        this.edgeArchetypes = edgeArchetypes;
+    }
+
+    public void setAttributeTypes(List<AttributeType> attributeTypes) {
+        this.attributeTypes = attributeTypes;
+    }
+
+    public void setPossibleEnumValues(Map<Integer, List<String>> possibleEnumValues) {
+        this.possibleEnumValues = new HashMap<>();
+        for (Integer index : possibleEnumValues.keySet()) {
+            this.possibleEnumValues.put("" + index, possibleEnumValues.get(index));
+        }
+    }
+
+    public void setArchetypeIcons(Map<String, String> archetypeIcons) {
+        this.archetypeIcons = archetypeIcons;
+    }
+
+    public List<String> getDefaultGroupArchetypes() {
+        return defaultGroupArchetypes;
+    }
+
+    public void setDefaultGroupArchetypes(List<String> defaultGroupArchetypes) {
+        this.defaultGroupArchetypes = defaultGroupArchetypes;
+    }
+
+    public List<AttributeType> getAttributeTypes() {
+        return attributeTypes;
+    }
+
+    public Map<String, List<String>> getPossibleEnumValues() {
+        return possibleEnumValues;
+    }
+
+    public Map<String, String> getArchetypeIcons() {
+        return archetypeIcons;
+    }
+
+    public Map<String, Vertex> getVertices() {
+        logger.trace("ENTRY");
+        logger.trace("EXIT");
+        return vertices;
+    }
+
+    public void addEdge(Edge edge) {
+        logger.trace("ENTRY");
+        this.edges.add(edge);
+        logger.trace("EXIT");
+    }
+
+    public void addVertex(String name, Vertex vertex) {
+        logger.trace("ENTRY");
+        this.vertices.put(name, vertex);
+        logger.trace("EXIT");
+    }
+}
